package org.greenstone.gsdl3.gs3build.database;

public class GS3SQLField
{ String name;
  int    length;
  String type;

    public final static String VARCHAR_TYPE = "VARCHAR";
    public final static String INTEGER_TYPE = "INTEGER";
    public final static String AUTOINTEGER_TYPE = "AUTOINTEGER";
    public final static String DATE_TYPE = "DATE";
    public final static String DATETIME_TYPE = "DATETIME";

    public GS3SQLField(String name)
    { this.name = name;
      this.length = 1024;
      this.type   = VARCHAR_TYPE;
    }

    public GS3SQLField(String name, int length)
    { this.name = name;
      this.length = length;
      this.type   = VARCHAR_TYPE;
    }

    public GS3SQLField(String name, String type)
    { this.name = name;
      this.type   = type;
      this.length = 1024;
    }

    public GS3SQLField(String name, String type, int length)
    { this.name = name;
      this.length = length;
      this.type   = type;
    }

    public String getName()
    { return this.name;
    }

    public int getLength()
    { return this.length;
    }

    public String toString()
    { StringBuffer reply = new StringBuffer();

      reply.append(this.name);
      reply.append(" ");
      if (this.type.equals(VARCHAR_TYPE))
      {
	if (length > 255) {
	  reply.append("TINYTEXT");
	}
	else {
	  reply.append("VARCHAR(");
	  reply.append(Integer.toString(this.length));
	  reply.append(")");
	}
      }
      else if (this.type.equals(AUTOINTEGER_TYPE))
      { reply.append("INTEGER AUTO_INCREMENT");
      }
      else
      {
	reply.append(this.type);
      }
      return reply.toString();
    }

}


